//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3AD73C3503D5.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3AD73C3503D5.cm

//## begin module%3AD73C3503D5.cp preserve=no
//## end module%3AD73C3503D5.cp

//## Module: SumComponent%3AD73C3503D5; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/SumComponent.h

#ifndef SUMCOMPONENT_H
#define SUMCOMPONENT_H 1

//## begin module%3AD73C3503D5.additionalIncludes preserve=no
//## end module%3AD73C3503D5.additionalIncludes

//## begin module%3AD73C3503D5.includes preserve=yes
//## end module%3AD73C3503D5.includes

// xsTypes
#include <main/xsTypes.h>
// Component
#include <XSModel/Model/Component/Component.h>
// MulComponent
#include <XSModel/Model/Component/MulComponent.h>
// MixComponent
#include <XSModel/Model/Component/MixComponent.h>
// ConComponent
#include <XSModel/Model/Component/ConComponent.h>
// MulTableComponent
#include <XSModel/Model/Component/MulTableComponent.h>

class AddComponent;
class CGroupBase;

//## begin module%3AD73C3503D5.declarations preserve=no
//## end module%3AD73C3503D5.declarations

//## begin module%3AD73C3503D5.additionalDeclarations preserve=yes
//## end module%3AD73C3503D5.additionalDeclarations


//## begin SumComponent%3767ED802A18.preface preserve=yes
//## end SumComponent%3767ED802A18.preface

//## Class: SumComponent%3767ED802A18
//	SumComponent is a component type which represents the
//	sum of a component group. It differs from AddComponent
//	in that
//	1) the count is not updated
//	2) the normalization parameter is 1, and is ignored.
//	3) model arithmetic (+=, +, *=, *) is defined on Sum
//	Components and between multiplicative types and Sum
//	Components and not on AddComponents
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A8C450D033B;CGroupBase { -> F}
//## Uses: <unnamed>%3AD73F6902A6;ConComponent { -> }
//## Uses: <unnamed>%3AD73F7D0004;MixComponent { -> }
//## Uses: <unnamed>%3C62B8DC039C;MulTableComponent { -> }
//## Uses: <unnamed>%3C62BC57026A;MulComponent { -> }
//## Uses: <unnamed>%3DD14A9A019E;AddComponent { -> F}

class SumComponent : public Component  //## Inherits: <unnamed>%3DD148960348
{
  //## begin SumComponent%3767ED802A18.initialDeclarations preserve=yes
  //## end SumComponent%3767ED802A18.initialDeclarations

  public:
    //## Constructors (generated)
      SumComponent(const SumComponent &right);

    //## Constructors (specified)
      //## Operation: SumComponent%3DB355D9FEED;    C++
      SumComponent (CGroupBase* p);

      //## Operation: SumComponent%3D07AF840398
      SumComponent (const AddComponent& right);

      //## Operation: SumComponent%48FF7CB00136
      SumComponent (const MulComponent& right);

    //## Destructor (generated)
      virtual ~SumComponent();


    //## Other Operations (specified)
      //## Operation: clone%38E3B99A2150
      virtual SumComponent* clone (CGroupBase* p) const;

      //## Operation: calculate%3A8BEE64034A
      virtual void calculate (bool saveComponentFlux, bool frozen);

      //## Operation: operator+=%3AD737D603CF;    C++
      //	+= operator for addition of two additives.
      //
      //	N.B. expects left hand expression to be pre-normalized.
      //
      //	The + operator does not expect the left expression
      //	to be normalized.
      SumComponent& operator += (const SumComponent& right);

      //## Operation: operator+%3AD737E9035E;    C++
      //	Additional Public Declarations
      SumComponent operator + (const SumComponent& right) const;

      //## Operation: isNested%3CE959D202C2
      virtual bool isNested () const;

      //## Operation: normalize%3CEA76470278
      void normalize ();

      //## Operation: norm%3D07727701E2
      virtual Real norm () const;

      //## Operation: savePhotonArray%3D0A1C55030F
      virtual void savePhotonArray (bool setSaveFlag);

      //## Operation: restorePhotonArray%3D0A1C5C02FA
      virtual void restorePhotonArray ();

      //## Operation: registerSelf%3F1D6CA3034B
      virtual void registerSelf () const;

      //## Operation: saveUniquePhotonArray%43D7BA54038D
      virtual void saveUniquePhotonArray (bool setSaveFlag = true);

      //## Operation: restoreUniquePhotonArray%43D7BADD03E3
      virtual void restoreUniquePhotonArray ();

      //## Operation: fillPhotonArrays%43D7BB040217
      void fillPhotonArrays ();

      //## Operation: clearPhotonArrays%43E8C10A009E
      void clearPhotonArrays ();

      //## Operation: toSumComponent%48FF7C010089
      //	Provides an alternative to dynamic_cast.
      virtual SumComponent* toSumComponent ();

      //## Operation: operator*=%4907568A0018
      SumComponent& operator *= (const Component& right);

      //## Operation: operator*%4907577500B5
      virtual SumComponent& operator * (SumComponent& right) const;

      //## Operation: photonArray%4B05CB1D01AA
      //	Non-const version is used by Model when folding its
      //	source components and calling its alignFluxForFold
      //	function.
      ArrayContainer& photonArray ();

      //## Operation: photonErrArray%4B05CB6F0248
      //	Non-const version is used by Model when folding its
      //	source components and calling its alignFluxForFold
      //	function.
      ArrayContainer& photonErrArray ();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::<unnamed>%3DF610C40158
      //## Role: SumComponent::foldedPhotonFlux%3DF610C5022C
      //## Qualifier: spectrumNumber%3DF6117C0238; size_t
      const ArrayContainer& foldedPhotonFlux () const;
      RealArray& foldedPhotonFlux (size_t spectrumNumber);

      //## Association: XSModel::Model::Component::<unnamed>%3DF61111028E
      //## Role: SumComponent::foldedPhotonFluxErr%3DF6111300EE
      //## Qualifier: spectrumNumber%3DF6115C02AC; size_t
      const ArrayContainer& foldedPhotonFluxErr () const;
      RealArray& foldedPhotonFluxErr (size_t spectrumNumber);

      //## Association: XSModel::Model::Component::<unnamed>%43E8BAC001AB
      //## Role: SumComponent::photonArray%43E8BAC2039C
      //## Qualifier: spectrumNumber%43E8BB020141; size_t
      const ArrayContainer& photonArray () const;
      const RealArray& photonArray (size_t spectrumNumber) const;

      //## Association: XSModel::Model::Component::<unnamed>%43E8C037036A
      //## Role: SumComponent::photonErrArray%43E8C0390111
      //## Qualifier: spectrumNumber%43E8C06001C1; size_t
      const ArrayContainer& photonErrArray () const;
      const RealArray& photonErrArray (size_t spectrumNumber) const;

    // Additional Public Declarations
      //## begin SumComponent%3767ED802A18.public preserve=yes
      friend class MixComponent;
      friend class ConComponent;
      friend class MulComponent;
      friend class ACNComponent;
      friend class AddComponent;
      //## end SumComponent%3767ED802A18.public
  protected:
    // Additional Protected Declarations
      //## begin SumComponent%3767ED802A18.protected preserve=yes
      //## end SumComponent%3767ED802A18.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3ADB272E0397
      void copy (const Component& right);

      //## Operation: swap%3DF615B802A0
      virtual void swap (Component& right);

    // Additional Private Declarations
      //## begin SumComponent%3767ED802A18.private preserve=yes
      //## end SumComponent%3767ED802A18.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: NORM%3F900FDD01BA
      //## begin SumComponent::NORM%3F900FDD01BA.attr preserve=no  private: static string {UC} "norm"
      static const string NORM;
      //## end SumComponent::NORM%3F900FDD01BA.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3DF610C40158
      //## begin SumComponent::foldedPhotonFlux%3DF610C5022C.role preserve=no  public: ArrayContainer { -> 1VHgN}
      ArrayContainer m_foldedPhotonFlux;
      //## end SumComponent::foldedPhotonFlux%3DF610C5022C.role

      //## Association: XSModel::Model::Component::<unnamed>%3DF61111028E
      //## begin SumComponent::foldedPhotonFluxErr%3DF6111300EE.role preserve=no  public: ArrayContainer { -> 1VHgN}
      ArrayContainer m_foldedPhotonFluxErr;
      //## end SumComponent::foldedPhotonFluxErr%3DF6111300EE.role

      //## Association: XSModel::Model::Component::<unnamed>%43E8BAC001AB
      //## begin SumComponent::photonArray%43E8BAC2039C.role preserve=no  public: ArrayContainer { -> 1VHgN}
      ArrayContainer m_photonArray;
      //## end SumComponent::photonArray%43E8BAC2039C.role

      //## Association: XSModel::Model::Component::<unnamed>%43E8C037036A
      //## begin SumComponent::photonErrArray%43E8C0390111.role preserve=no  public: ArrayContainer { -> 1VHgN}
      ArrayContainer m_photonErrArray;
      //## end SumComponent::photonErrArray%43E8C0390111.role

    // Additional Implementation Declarations
      //## begin SumComponent%3767ED802A18.implementation preserve=yes
      //## end SumComponent%3767ED802A18.implementation

};

//## begin SumComponent%3767ED802A18.postscript preserve=yes
//## end SumComponent%3767ED802A18.postscript

// Class SumComponent 


//## Other Operations (inline)
inline SumComponent* SumComponent::toSumComponent ()
{
  //## begin SumComponent::toSumComponent%48FF7C010089.body preserve=yes
   return this;
  //## end SumComponent::toSumComponent%48FF7C010089.body
}

inline ArrayContainer& SumComponent::photonArray ()
{
  //## begin SumComponent::photonArray%4B05CB1D01AA.body preserve=yes
   return m_photonArray;
  //## end SumComponent::photonArray%4B05CB1D01AA.body
}

inline ArrayContainer& SumComponent::photonErrArray ()
{
  //## begin SumComponent::photonErrArray%4B05CB6F0248.body preserve=yes
   return m_photonErrArray;
  //## end SumComponent::photonErrArray%4B05CB6F0248.body
}

//## Get and Set Operations for Associations (inline)

inline const ArrayContainer& SumComponent::foldedPhotonFlux () const
{
  //## begin SumComponent::foldedPhotonFlux%3DF610C5022C.get preserve=no
  return m_foldedPhotonFlux;
  //## end SumComponent::foldedPhotonFlux%3DF610C5022C.get
}

inline RealArray& SumComponent::foldedPhotonFlux (size_t spectrumNumber)
{
  //## begin SumComponent::foldedPhotonFlux%3DF610C5022C.qualget preserve=no
  return m_foldedPhotonFlux[spectrumNumber];
  //## end SumComponent::foldedPhotonFlux%3DF610C5022C.qualget
}

inline const ArrayContainer& SumComponent::foldedPhotonFluxErr () const
{
  //## begin SumComponent::foldedPhotonFluxErr%3DF6111300EE.get preserve=no
  return m_foldedPhotonFluxErr;
  //## end SumComponent::foldedPhotonFluxErr%3DF6111300EE.get
}

inline RealArray& SumComponent::foldedPhotonFluxErr (size_t spectrumNumber)
{
  //## begin SumComponent::foldedPhotonFluxErr%3DF6111300EE.qualget preserve=no
  return m_foldedPhotonFluxErr[spectrumNumber];
  //## end SumComponent::foldedPhotonFluxErr%3DF6111300EE.qualget
}

inline const ArrayContainer& SumComponent::photonArray () const
{
  //## begin SumComponent::photonArray%43E8BAC2039C.get preserve=no
  return m_photonArray;
  //## end SumComponent::photonArray%43E8BAC2039C.get
}

inline const ArrayContainer& SumComponent::photonErrArray () const
{
  //## begin SumComponent::photonErrArray%43E8C0390111.get preserve=no
  return m_photonErrArray;
  //## end SumComponent::photonErrArray%43E8C0390111.get
}

//## begin module%3AD73C3503D5.epilog preserve=yes
//## end module%3AD73C3503D5.epilog


#endif
